*****************************************************;
* M&S K2b@JԂ̂V~[V       ; 
*                                                    ;
* K.KOMATSU                                          ;
*****************************************************;

*z팱Ҕwif[^ǂݍ;
DATA Background;
 infile "C:\NONMEM\2009_MPU_Text\04_PD3Simulation_091220\Exercise_2b\SAS\MS_DATA_2007_for_Sim.csv"
 dlm="," firstobs=2;
 input ID TIME DOS RACE AGE WGHT BSA CCR ALBU SMOK EED;
RUN;

%LET nSim= 100;   *JԂ;
%LET nDose= 10;    *pʐ̐;
%LET number=100;  *Q̔팱Ґ;
%LET nAll =%EVAL(&nDose * &number); *1JԂ̔팱Ґ;

*dăTvOAResampled_1֊i[;
ods listing close;
PROC SURVEYSELECT data=Background out=Resampled_1
 method=URS rep=%EVAL(&nSim) n=%EVAL(&nAll) outhits;
RUN;

*pʂ̊t̂߂̗RUAResampled_2֊i[;
DATA Resampled_2;
 set Resampled_1;
 R = RAND("UNIFORM");
RUN;

*Ƀ\[gAResampled_3;
PROC SORT data=Resampled_2 out=Resampled_3;by Replicate R;RUN;

*pʊt̂߂̗pʃf[^ZbgADose쐬;
*񐔂킹č쐬;
DATA Dose;
 do Replicate = 1 to &nSim;
  do simDOSE = 0, 25,50,75,100,125,150,175,200,250;
	  do i = 1 to &number;
		output;
	  end;
	end;
 end;
RUN;

*pʂResampled_3}[W邱Ƃŗpʂt;
DATA Resampled_4;
 merge Dose Resampled_3;
RUN;

*PKV~[V;
DATA Resampled_5;
 set Resampled_4;
 TVCL = 56.2;
 CL = TVCL * EXP(RAND("NORMAL",0,sqrt(0.05)));
 TV = 0.014 + (BSA-2.1) * 2.51;
 V = TV * EXP(RAND("NORMAL",0,sqrt(0.014)));
 TKA = 0.23;
 if EED = 2 then TKA=0.23*1.54;
 KA = TKA * EXP(RAND("NORMAL",0,sqrt(0.012)));
 AL1=0.84*EXP(RAND("NORMAL",0,sqrt(0.01)));
 SC = V;
 TF1 = 1;
 if simDose ge 100 then TF1 = (100 - (simDose-100)*0.387)/100;
 if simDOSE=200 then TF1 = 0.613;
 F1=TF1*EXP(RAND("NORMAL",0,sqrt(0.02)));
 AUC=simDOSE*1000*F1/CL;
RUN;

*PDV~[V;
DATA Resampled_6;
 set Resampled_5;
 AUCN = AUC / 1000;
 WKS = TIME / 24/ 7;
 BAS = -4.02 + 0.756 * WKS -0.225 * (AGE-56.4);
 PROP = 3.16;
 EMAX = 4.81;
 EC50 = 1.17;
 if SMOK >= 3 then EC50 = EC50*1.83;

 EDC = EMAX * AUCN/(EC50 + AUCN);
 LGT = BAS + EDC + RAND("NORMAL",0, sqrt(5.86));
 LGTF = LGT + PROP;
 PP = 1 / (1 + EXP(-LGT));
 PF = 1 / (1 + EXP(-LGTF));
 R=RAND("UNIFORM");
 if R >= PF then PD3 = 1;
 else if R >= PP then PD3  =2;
 else PD3 = 3;
 if PD3 = 3 or PD3 = 2 then PD2 = 1;
 else PD2 = 0;
RUN;

ods output CrosstabFreqs=out;
PROC FREQ data=Resampled_6;
 by Replicate;
 tables PD3 * simDOSE / nopercent norow;
RUN;

DATA Result;
 set out;
 where (simDOSE ^= Missing) AND (PD3 ^= Missing);
 if Colpercent="." then delete;
 drop Table _TABLE_ _TYPE_ Missing;
RUN;

PROC SORT data=Result out=Result_2;by simDose PD3;RUN;

ods listing close;
PROC UNIVARIATE data=Result_2;
 by simDose PD3;
 where PD3 = 3;
 var Colpercent;
 output out=Summary MEAN=MEAN PCTLPRE=P_ PCTLPTS=5,95;
RUN;
